Index: pjproject/trunk/pjmedia/include/pjmedia/transport.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/transport.h	(revision 1943)
+++ pjproject/trunk/pjmedia/include/pjmedia/transport.h	(revision 1944)
@@ -305,4 +305,18 @@
 			     const void *pkt,
 			     pj_size_t size);
+
+    /**
+     * This function is called by the stream to send RTCP packet using the
+     * transport with destination address other than default specified in
+     * #pjmedia_transport_attach().
+     *
+     * Application should call #pjmedia_transport_send_rtcp2() instead of 
+     * calling this function directly.
+     */
+    pj_status_t (*send_rtcp2)(pjmedia_transport *tp,
+			      const pj_sockaddr_t *addr,
+			      unsigned addr_len,
+			      const void *pkt,
+			      pj_size_t size);
 
     /**
@@ -588,4 +602,29 @@
 
 /**
+ * Send RTCP packet with the specified media transport. This is just a simple
+ * wrapper which calls <tt>send_rtcp2()</tt> member of the transport. The 
+ * RTCP packet will be delivered to the destination address specified in
+ * param addr, if addr is NULL, RTCP packet will be delivered to destination 
+ * address specified in #pjmedia_transport_attach() function.
+ *
+ * @param tp	    The media transport.
+ * @param addr	    The destination address.
+ * @param addr_len  Length of destination address.
+ * @param pkt	    The packet to send.
+ * @param size	    Size of the packet.
+ *
+ * @return	    PJ_SUCCESS on success, or the appropriate error code.
+ */
+PJ_INLINE(pj_status_t) pjmedia_transport_send_rtcp2(pjmedia_transport *tp,
+						    const pj_sockaddr_t *addr,
+						    unsigned addr_len,
+						    const void *pkt,
+						    pj_size_t size)
+{
+    return (*tp->op->send_rtcp2)(tp, addr, addr_len, pkt, size);
+}
+
+
+/**
  * Generate local SDP parts that are related to the specified media transport.
  * Remote SDP might be needed as reference when application is in deciding
Index: pjproject/trunk/pjmedia/src/pjmedia/transport_ice.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_ice.c	(revision 1943)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_ice.c	(revision 1944)
@@ -76,4 +76,9 @@
 				       const void *pkt,
 				       pj_size_t size);
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+				       const pj_sockaddr_t *addr,
+				       unsigned addr_len,
+				       const void *pkt,
+				       pj_size_t size);
 static pj_status_t transport_media_create(pjmedia_transport *tp,
 				       pj_pool_t *pool,
@@ -111,4 +116,5 @@
     &transport_send_rtp,
     &transport_send_rtcp,
+    &transport_send_rtcp2,
     &transport_media_create,
     &transport_media_start,
@@ -771,9 +777,21 @@
 				       pj_size_t size)
 {
+    return transport_send_rtcp2(tp, NULL, 0, pkt, size);
+}
+
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+				        const pj_sockaddr_t *addr,
+				        unsigned addr_len,
+				        const void *pkt,
+				        pj_size_t size)
+{
     struct transport_ice *tp_ice = (struct transport_ice*)tp;
     if (tp_ice->ice_st->comp_cnt > 1) {
-	return pj_ice_strans_sendto(tp_ice->ice_st, 2, 
-				    pkt, size, &tp_ice->remote_rtcp,
-				    sizeof(pj_sockaddr_in));
+	if (addr == NULL) {
+	    addr = &tp_ice->remote_rtcp;
+	    addr_len = pj_sockaddr_get_len(addr);
+	}
+	return pj_ice_strans_sendto(tp_ice->ice_st, 2, pkt, size, 
+				    addr, addr_len);
     } else {
 	return PJ_SUCCESS;
Index: pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 1943)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_srtp.c	(revision 1944)
@@ -146,4 +146,9 @@
 				       const void *pkt,
 				       pj_size_t size);
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+				       const pj_sockaddr_t *addr,
+				       unsigned addr_len,
+				       const void *pkt,
+				       pj_size_t size);
 static pj_status_t transport_media_create(pjmedia_transport *tp,
 				       pj_pool_t *pool,
@@ -172,4 +177,5 @@
     &transport_send_rtp,
     &transport_send_rtcp,
+    &transport_send_rtcp2,
     &transport_media_create,
     &transport_media_start,
@@ -658,4 +664,13 @@
 				       pj_size_t size)
 {
+    return transport_send_rtcp2(tp, NULL, 0, pkt, size);
+}
+
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+				        const pj_sockaddr_t *addr,
+				        unsigned addr_len,
+				        const void *pkt,
+				        pj_size_t size)
+{
     pj_status_t status;
     transport_srtp *srtp = (transport_srtp*) tp;
@@ -663,6 +678,8 @@
     err_status_t err;
 
-    if (srtp->bypass_srtp)
-	return pjmedia_transport_send_rtcp(srtp->real_tp, pkt, size);
+    if (srtp->bypass_srtp) {
+	return pjmedia_transport_send_rtcp2(srtp->real_tp, addr, addr_len, 
+	                                    pkt, size);
+    }
 
     if (!srtp->session_inited)
@@ -678,6 +695,6 @@
     
     if (err == err_status_ok) {
-	status = pjmedia_transport_send_rtcp(srtp->real_tp, srtp->tx_buffer, 
-					     len);
+	status = pjmedia_transport_send_rtcp2(srtp->real_tp, addr, addr_len,
+					      srtp->tx_buffer, len);
     } else {
 	status = PJMEDIA_ERRNO_FROM_LIBSRTP(err);
@@ -688,4 +705,5 @@
     return status;
 }
+
 
 static pj_status_t transport_simulate_lost(pjmedia_transport *tp,
Index: pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1943)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1944)
@@ -122,4 +122,9 @@
 				       const void *pkt,
 				       pj_size_t size);
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+				       const pj_sockaddr_t *addr,
+				       unsigned addr_len,
+				       const void *pkt,
+				       pj_size_t size);
 static pj_status_t transport_media_create(pjmedia_transport *tp,
 				       pj_pool_t *pool,
@@ -147,4 +152,5 @@
     &transport_send_rtp,
     &transport_send_rtcp,
+    &transport_send_rtcp2,
     &transport_media_create,
     &transport_media_start,
@@ -749,4 +755,15 @@
 				       pj_size_t size)
 {
+    return transport_send_rtcp2(tp, NULL, 0, pkt, size);
+}
+
+
+/* Called by application to send RTCP packet */
+static pj_status_t transport_send_rtcp2(pjmedia_transport *tp,
+					const pj_sockaddr_t *addr,
+					unsigned addr_len,
+				        const void *pkt,
+				        pj_size_t size)
+{
     struct transport_udp *udp = (struct transport_udp*)tp;
     pj_ssize_t sent;
@@ -755,8 +772,12 @@
     PJ_ASSERT_RETURN(udp->attached, PJ_EINVALIDOP);
 
+    if (addr == NULL) {
+	addr = &udp->rem_rtcp_addr;
+	addr_len = udp->addr_len;
+    }
+
     sent = size;
     status = pj_ioqueue_sendto( udp->rtcp_key, &udp->rtcp_write_op,
-				pkt, &sent, 0,
-				&udp->rem_rtcp_addr, udp->addr_len);
+				pkt, &sent, 0, addr, addr_len);
 
     if (status==PJ_SUCCESS || status==PJ_EPENDING)